/****************************************************************************
**
** Copyright (C) 1992-2004 Trolltech AS. All rights reserved.
**
** This file is part of the core module of the Qt Toolkit.
**
** Licensees holding valid Qt Preview licenses may use this file in
** accordance with the Qt Preview License Agreement provided with the
** Software.
**
** See http://www.trolltech.com/pricing.html or email sales@trolltech.com for
** information about Qt Commercial License Agreements.
**
** Contact info@trolltech.com if any conditions of this licensing are
** not clear to you.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
****************************************************************************/

#include "qspinlock_p.h"

#ifndef QT_NO_THREAD
void QSpinLock::initialize()
{
    pthread_mutex_init(&mutex, 0);
    pthread_cond_init(&cond, 0);
}

void QSpinLock::cleanup()
{
    pthread_mutex_destroy(&mutex);
    pthread_cond_destroy(&cond);
}

void QSpinLock::wait()
{
    pthread_mutex_lock(&mutex);
    while (!q_atomic_test_and_set_int(&lock, 0, ~0))
        pthread_cond_wait(&cond, &mutex);
    pthread_mutex_unlock(&mutex);
}

void QSpinLock::wake()
{
    pthread_mutex_lock(&mutex);
    pthread_cond_signal(&cond);
    pthread_mutex_unlock(&mutex);
}
#endif // QT_NO_THREAD
